# United States English language file.
#
# Denora (c) 2004-2005 Denora Team
# Contact us at dev@nomadirc.net
#
# This program is free but copyrighted software; see the file COPYING for
# details.
#
# Based on the original code of Anope by Anope Team.
# Based on the original code of Thales by Lucas.
#
# $Id: fr.l 436 2005-07-26 22:50:42Z crazy $
#
# French tracution by XaF
# Traduction Franaise par XaF
#			(root@sbird.org - irc.sbird.org)
#
#
# When translating this file to another language, keep in mind that the
# order of parameters for sprintf() is fixed in the source code, so your
# messages need to take the same parameters in the same order as the
# English messages do.  (Obviously, this doesn't hold for the strftime()
# format lines immediately below.)  If you can't get a natural translation
# of a message without changing the order of the parameters, let us know
# (dev@nomadirc.net) which message is causing a problem and I'll see
# what I can do.
#
# In help messages, "%S" (capital S, not lowercase) refers to the name of
# the service sending the message; for example, in StatServ help messages,
# "%S" is replaced by "StatServ" (or whatever it is renamed to in
# denora.conf).  The %S's do not count as sprintf() parameters, so they can be
# rearranged, removed, or added as necessary.
#
# Also in help messages, please try to limit line lengths to 60 characters
# of text (not including the leading tab).  This length was chosen because
# it does not cause line wrap under default settings on most current IRC
# clients.  Remember that format characters (control-B, control-_) are not
# included in that 60-character limit (since they don't show on the user's
# screen).  Also remember that format specifiers (%S, etc.) will expand
# when displayed, so remember to take this into account; you can assume
# that the length of a pseudoclient name (%S replacement) will be eight
# characters, so reduce the maximum line length by 6 for every %S on a
# line.
#
# Finally, remember to put a tab at the beginning of every line of text
# (including empty lines).  This has to be a tab, not spaces.

###########################################################################
#
# Name of this language
#
###########################################################################

# For languages other than English, this string should have the following
# format:
#     language-name-in-language (language-name-in-English)
# For example, "Espaol (Spanish)" or "Franais (French)".

LANG_NAME
	Franais (French)

###########################################################################
#
# General messages
#
###########################################################################

# strftime() format strings.  man 3 strftime for information on the
# meanings of the format specifiers.  Short version:
#	%a = weekday name (short)	%H = hour
#	%b = month name (short)		%M = minute
#	%d = day of month		%S = second
#	%Y = year			%Z = time zone

# This is used as the format string for strftime() for a date and time
# together.
STRFTIME_DATE_TIME_FORMAT
	%b %d %H:%M:%S %Y %Z
# This is used as the format string for strftime() for a date alone in long
# format (English: including weekday).
STRFTIME_LONG_DATE_FORMAT
	%a %b %d %Y
# This is used as the format string for strftime() for a date alone in
# short format (English: without weekday).
STRFTIME_SHORT_DATE_FORMAT
	%b %d %Y

# These tell our strftime() what the names of months and days are.  If you
# don't use %a, %A, %b, or %B in your strftime() strings above, you can
# leave these empty.  However, if you enter names, they MUST stay in order,
# one per line, and the list MUST be complete!

# %a
STRFTIME_DAYS_SHORT
	Dim
	Lun
	Mar
	Mer
	Jeu
	Ven
	Sam
# %A
STRFTIME_DAYS_LONG
	Dimanche
	Lundi
	Mardi
	Mercredi
	Jeudi
	Vendredi
	Samedi
# %b
STRFTIME_MONTHS_SHORT
	Jan
	Fev
	Mar
	Avr
	Mai
	Juin
	Juil
	Aou
	Sep
	Oct
	Nov
	Dec
# %B
STRFTIME_MONTHS_LONG
	Janvier
	Fvrier
	Mars
	Avril
	Mai
	Juin
	Juillet
	Aot
	Septembre
	Octobre
	Novembre
	Decembre


# This is used in ChanServ/NickServ INFO displays.
COMMA_SPACE
	, 


# Various error messages.
USER_RECORD_NOT_FOUND
	Erreur interne - impossible de procder  la requte.
UNKNOWN_COMMAND
	Commande %s inconnue.
UNKNOWN_COMMAND_HELP
	Commande %s inconnue. Tapez "/msg %s HELP" pour obtenir de l'aide.
SYNTAX_ERROR
	Synthaxe: %s
MORE_INFO
	/msg %s HELP %s pour plus d'informations.
NO_HELP_AVAILABLE
	Aucune aide disponible sur %s.

SERVICE_OFFLINE
	%s sont actuellement hors-ligne.

SQL_DISABLED
	You can not use this command, the SQL code is disabled.

STATS_UPTIME_DHMS
	Stats up %d days, %02d:%02d:%02d
STATS_UPTIME_1DHMS
	Stats up %d day, %02d:%02d:%02d
STATS_UPTIME_HMS
	Stats up %d hours, %d minutes, %d seconds
STATS_UPTIME_HM1S
	Stats up %d hours, %d minutes, %d second
STATS_UPTIME_H1MS
	Stats up %d hours, %d minute, %d seconds
STATS_UPTIME_H1M1S
	Stats up %d hours, %d minute, %d second
STATS_UPTIME_1HMS
	Stats up %d hour, %d minutes, %d seconds
STATS_UPTIME_1HM1S
	Stats up %d hour, %d minutes, %d second
STATS_UPTIME_1H1MS
	Stats up %d hour, %d minute, %d seconds
STATS_UPTIME_1H1M1S
	Stats up %d hour, %d minute, %d second
STATS_UPTIME_MS
	Stats up %d minutes, %d seconds
STATS_UPTIME_M1S
	Stats up %d minutes, %d second
STATS_UPTIME_1MS
	Stats up %d minute, %d seconds
STATS_UPTIME_1M1S
	Stats up %d minute, %d second

# What's the difference between "Access denied" and "Permission denied"?
# Very little; you can safely make them the same message with no real loss
# of meaning.  If you want to make a distinction, "Access denied" is
# usually used more generally; for example, a non-oper trying to access
# StatServ gets "Access denied", while a non-Stas admin trying to use
# StatServ RESTART gets "Permission denied".
ACCESS_DENIED
	Accs refus.
PERMISSION_DENIED
	Permission refuse.

# Oh yeah, too simple messages, but useful. Here yes means yes and
# no means no, so take it easy.
SAY_YES
	Yes
SAY_NO
	No

###########################################################################
#
# StatServ messages
#
###########################################################################

# RESTART responses
STAT_CANNOT_RESTART
	STATS_BIN n'est pas dfini; impossible de restart. Relancez le script \2configure\2
	et recompilez Denora pour activer la commande RESTART.

# Module strings

STAT_MODULE_LOADED
	Module %s charg
STAT_MODULE_UNLOADED
	Module %s dcharg
STAT_MODULE_LOAD_FAIL
	Impossible de charger le module %s
STAT_MODULE_REMOVE_FAIL
	Impossible de dcharger le module %s
STAT_MODULE_LOAD_SYNTAX
	MODLOAD nom du fichier
STAT_MODULE_UNLOAD_SYNTAX
	MODUNLOAD nom du fichier
STAT_MODULE_NO_UNLOAD
	Ce module ne peux pas tre dcharg.
STAT_MODULE_LIST_HEADER
	Liste des modules actuellement chargs:
STAT_MODULE_LIST
	Module: %s [%s] [%s]
STAT_MODULE_LIST_FOOTER
	%d Modules chargs.
STAT_MODULE_INFO_LIST
	Module: %s Version: %s Auteur: %s Charg: %s
STAT_MODULE_CMD_LIST
	Commande ajoute: /msg %s %s
STAT_MODULE_MSG_LIST
	Providing IRCD handler for: %s
STAT_MODULE_NO_LIST
	Aucun module charg actuellement
STAT_MODULE_NO_INFO
	Aucune information sur le module %s n'est disponible
STAT_MODULE_INFO_SYNTAX
	MODINFO nom du fichier
MODULE_HELP_HEADER
	Les commandes suivantes ont t charges par un module:

###########################################################################
#
# StatServ help messages
#
###########################################################################

STAT_HELP
	%S commands:
	    STATS       Afficher les statistiques du rseau
	    LOGIN       Vous identifier comme un Administrateur des Stats
	    LOGOUT      Retirer votre statut d'admin

STAT_HELP_STATS
	Synthaxe: STATS
	
	Affiche le nombre de serveurs, salons et utilisateurs
	connects au rseau actuellement.

STAT_HELP_SHUTDOWN
	Synthaxe: SHUTDOWN
	
	Arrte les services aprs avoir sauvegard toutes les bases de donnes.
	
	Limit aux Administrateurs des Stats.

STAT_HELP_RESTART
	Synthaxe: RESTART
	
	Relance Denora.
	(i.e. coupe puis relance immdiatement l'excutable).

STAT_HELP_RELOAD
	Synthaxe: RELOAD
	
	Permet de recharger le fichier de configuration de Denora.

STAT_HELP_ADMIN_CMD
	Commandes rserves aux Administrateurs des Stats:
	    CHANSTATS   Ajoute un salon  monitorer
	    ENVINFO     Show enviroment information
	    EXCLUDE     Exclus des utilisateurs/salons des stats
	    EXPORT      Exporte les donnes dans un fichier XML
	    HTML        Force la cration du fichier HTML
	    MODLOAD     Charge un module
	    MODUNLOAD   Dcharge un module
	    MODLIST     Liste les modules chargs
	    MODINFO     Informations sur un module charg
	    RESTART     Relance Denora
	    RELOAD      Recharger le fichier de configuration
	    SHUTDOWN    Arrtes Denora en sauvegardant les bdd

STAT_HELP_MODLOAD
	Synthaxe: MODLOAD nom du fichier

	Cette commande charge le module nomm "nom du fichier" tant
	dans le dossier "modules".

	Limit aux Administrateurs des Stats.

STAT_HELP_MODUNLOAD
	Synthaxe: MODUNLOAD nom du fichier

	Cette commande dcharge le module nomm "nom du fichier" tant
	dans le dossier "modules".

	Limit aux Administrateurs des Stats.

STAT_HELP_MODINFO
	Synthaxe: MODINFO nom du fichier

	Cette commande affiche les informations sur le module charg
	spcifi.

	Limit aux Administrateurs des Stats.

STAT_HELP_MODLIST
	Synthaxe: MODLIST

	Liste les modules chargs actuellement.

	Limit aux Administrateurs des Stats.

STAT_HELP_EXCLUDE
	Synthaxe: EXCLUDE {ADD|DEL} cible
	
	Exclus la cible des statistiques.
	
	Limit aux Administrateurs des Stats.

STAT_HELP_EXPORT
	Syntax: EXPORT what
	
	Export the required data to XML, where
	what is one of the following options:
	
	channels,users,tld,servers,stats,all
	
	Limited to Stats Admins

STAT_HELP_HTML
	Synthaxe: HTML
	
	Force la cration du fichier HTML

STAT_HELP_USERDEBUG
	Synthaxe: USERDEBUG utilisateur 
	
	Retourne les informations de DEBUG sur l'utilisateur
	donn.

STAT_HELP_LOGIN
	Synthaxe: LOGIN name password
	
	Vous identifier comme un Administrateur des Stats

STAT_HELP_LOGOUT
	Synthaxe: LOGOUT
	
	Retirer votre statut d'admin

STAT_HELP_SET
	Synthaxe: SET OPTION [ON|OFF]

	Diverses options avec rgles d'excution.

	Limit aux Administrateurs des Stats.

STAT_HELP_ENVINFO
	Syntax: ^BENVINFO^B
	
	Show enviroment information.
	
	Limited to Stats Admins.

###########################################################################
#
# ADMIN messages
#
###########################################################################

STAT_ADMIN_LOGGED_IN
	Vous tes maintenant Administrateur des Stats.

STAT_ADMIN_LOGGED_OUT
	Vous n'tes plus Administrateur des Stats.

STAT_ADMIN_ALREADY_LOGGED
	Vous tes dj Administrateur des Stats!

STAT_LOGIN_SYNTAX
	LOGIN id mot de passe

STAT_RELOAD
	Le fichier de configuration des Stats a t recharg.

###########################################################################
#
# STATS messages
#
###########################################################################

STAT_STATS_SERVER_COUNT
	Statistiques des serveurs pour %s:
	
	Serveurs actuellement relis:  %d
	Maximum de serveurs relis: %d

STAT_STATS_CHAN_COUNT
	Statistiques des salons pour %s:
	
	Salons actuellement utiliss:  %d
	Maximum de salons crs: %d

STAT_STATS_USER_COUNT
	Statistiques des utilisateurs pour %s:
	
	Utilisateurs actuellement connects:  %d
	Maximum d'utilisateurs connects: %d

STAT_STATS_SYNTAX
	STATS [SERVERS|CHANNELS|USERS]

# SET responses
STAT_SET_SYNTAX
	SET option paramtres
STAT_SET_DEBUG_ON
	DEBUG mode des stats activ.
STAT_SET_DEBUG_OFF
	DEBUG mode des stats dsactiv.
STAT_SET_DEBUG_LEVEL
	DEBUG mode des stats activ (niveau %d).
STAT_SET_DEBUG_ERROR
	Les paramtres pour DEBUG doivent tre ON, OFF, ou un nombre positif.
STAT_SET_UNKNOWN_OPTION
	Option SET %s inconnue.
STAT_SET_SQL_ON
	Le code SQL sera utilis.
STAT_SET_SQL_OFF
	Le code SQL ne sera pas utilis.
STAT_SET_SQL_ERROR
	Les paramtres pour SQL doivent tre ON ou OFF.
STAT_SET_SQL_ERROR_INIT
	Erreur pendant l'initialisation d'SQL, regardez les logs.
STAT_SET_SQL_ERROR_DISABLED
	SQL n'est pas configur pour ce rseau, merci d'diter le
	fichier de configuration (denora.conf).
STAT_SET_LIST_OPTION_ON
	%s est activ
STAT_SET_LIST_OPTION_OFF
	%s est dsactiv
STAT_SET_HTML_ON
	La pages HTML seront gnres.
STAT_SET_HTML_OFF
	La pages HTML ne seront pas gnres.
STAT_SET_HTML_ERROR
	Les paramtres pour HTML doivent tre ON ou OFF.

# CHANSTATS responses
STAT_HELP_CHANSTATS
	Les statistiques de salon vous permettent de grer ceux-ci comme
	les eggdrops et d'obtenir des informations sur le nombre de lettres,
	le nombre de lignes, etc...
	
	CHANSTATS ADD channel
	CHANSTATS DEL channel
	CHANSTATS LIST
	CHANSTATS SET channel FANTASY {ON|OFF|NOTICE}
	CHANSTATS SUMUSER utilisateur1 utilisateur2
	
	The CHANSTATS ADD command adds the given channel to the monitored
	channels list.
	
	The CHANSTATS DEL command removes the given channel from the
	monitored channels list.
	
	The CHANSTATS LIST command shows you the list of the monitored
	channles on the network.
	
	The CHANSTATS SET command activates the fantasy commands for the
	given channel. You can make StatServ to show them using normal
	private messages to the channel (ON), or using notices instead.
	
	The CHANSTATS SUMUSER command transfers all stats from user2
	to user1 and deletes user2.

STAT_CHANSTATS_SYNTAX
	CHANSTATS {ADD|DEL|LIST|SUMUSER|SET} [CHAN|USER|OPTION]

STAT_CHANSTATS_CHAN_ADDED
	%s est maintenant paramtr pour tre monitor par les stats salons.

STAT_CHANSTATS_CHAN_LARGENET
	LargeNet is enabled you can not added new channels.

STAT_CHANSTATS_LOGCHAN
	LogChannel can not be added to channel stats

STAT_CHANSTATS_NOT_VALID_CHAN
	You have not entered a valid channel name

STAT_CHANSTATS_CHAN_ALREADY
	%s est dj paramtr pour tre monitor par les stats salons.

STAT_CHANSTATS_ADD_SYNTAX
	CHANSTATS ADD channel

STAT_CHANSTATS_DEL_SYNTAX
	CHANSTATS DEL channel

STAT_CHANSTATS_CHAN_DEL
	%s n'est dsormais plus paramtr pour tre monitor par les stats salons.

STAT_CHANSTATS_CHAN_NOTFOUND
	%s n'est pas paramtr pour tre monitor par les stats salons.

STATS_CHANSTATS_PART
	Arrt de la surveillance de %s

STATS_CHANSTATS_NOCHANNELS
	Aucun salon monitor  lister

STATS_CHANSTATS_SET_SYNTAX
	CHANSTATS SET channel FANTASY {ON|OFF|NOTICE}

STATS_CHANSTATS_FANTASY_ON
	Les commandes de fantaisie pour %s sont dsormais actives

STATS_CHANSTATS_FANTASY_OFF
	Les commandes de fantaisie pour %s sont dsormais dsactives

STATS_CHANSTATS_FANTASY_NOTICE
	Les commandes de fantaisie pour %s seront dsormais notices

STATS_CHANSTATS_SUMUSER_SYNTAX
	CHANSTATS SUMUSER utilisateur1 utilisateur2

# EXCLUDE responses
STAT_EXCLUDE_SYNTAX
	EXCLUDE {ADD|DEL} cible

STAT_EXCLUDE_ADDED
	%s sera dsormais exclus des statistiques

STAT_EXCLUDE_ALREADY
	%s est dj exclus des statistiques

STAT_EXCLUDE_DELETED
	%s ne sera dsormais plus exclus des statistiques

STAT_EXCLUDE_NOT_FOUND
	%s n'est pas exclus des statistiques

STAT_EXCLUDE_LIST_HEADER
	Exclude List

# EXPORT responses
STATS_EXPORT_CHANNELS
	Export des salons sur %s

STATS_EXPORT_USERS
	Export des utilisateurs sur %s

STATS_EXPORT_TLD
	Export des TLD sur %s

STATS_EXPORT_SERVERS
	Export des serveurs sur %s

STATS_EXPORT_STATS
	Export des stats sur %s

STATS_EXPORT_ALL
	Exported de toutes les informations sur %s

STATS_EXPORT_SYNTAX
	EXPORT {CHANNELS|USERS|TLD|SERVERS|STATS|ALL}

STATS_SUMUSER_NOTFOUND
	%s n'existe pas dans la base de donnes des statistiques.

STATS_HELP_CHANNEL_1
	The following fantasy commands are available

STATS_HELP_CHANNEL_2
	!top10  :   The top 10 users of the current channel
	!top    :   The top 3  users of the current channel
	!gtop10 :   The top 10 users of the whole network
	!gtop   :   The top 3  users of the whole network
	!stats  :   User stats for the channel
	!gstats :   User stats for the network
	!peak   :   User peak for the current channel

STATS_TOP10_CHANNEL
	Top 10 de %s

STATS_TOP_CHANNEL
	Top 3 de %s

STATS_TOP10_NETWORK
	Top 10 du Rseau

STATS_TOP_NETWORK
	Top 3 du Rseau

STATS_USER_NETWORK
	Network stats for %s

STATS_USER_CHANNEL
	Channel stats for %s on %s

STATS_MESSAGE
	%2i %-16s lettres: %s, mots: %s, lignes: %s, sourires: %s, actions: %s

STATS_MESSAGE_ONE
	letters: %s, words: %s, lines: %s, smileys: %s, actions: %s

STATS_CHANNEL_PEAK
	Channel user peak was %d

# ENVINFO responses
STAT_ENVINFO_HEADER
	Enviroment information for Stats:
STAT_ENVINFO_VERSION
	Stats version:            %s
STAT_ENVINFO_PROTOCOL
	IRCd protocol:            %s
STAT_ENVINFO_UPLINK
	Stats uplink:             %s
STAT_ENVINFO_SQL
	SQL code:                 %s
STAT_ENVINFO_HTML
	HTML code:                %s
STAT_ENVINFO_DEBUG
	Debugging:                %s
STAT_ENVINFO_MODULESLOADED
	Number of loaded modules: %d
STAT_ENVINFO_LANGUAGE
	Network language:         %s
STAT_ENVINFO_FOOTER
	End of Enviroment Information

STATS_HTML_EXPORTED
	Stats HTML file has been generated

# HTML code
HTML_LANG
	<META HTTP-EQUIV="CHARSET" CONTENT="ISO-8859-1">
	<META HTTP-EQUIV="CONTENT-LANGUAGE" CONTENT="French">

HTML_NETSTATS_HEADER
	<table border = 0><tr><th colspan="4"><b>Statistiques Rseau:</b></th></tr>

HTML_NETSTATS_FOOTER
	</table>

HTML_NETSTATS_USERS
	<td>Utilisateurs Actuels: </td> <td> %ld </td> <td>Utilisateurs Maximum: </td> <td> %ld [%s] </td></tr>

HTML_NETSTATS_CHANS
	<tr><td>Salons Actuels: </td> <td> %ld </td> <td>Salons Maximum: </td> <td> %ld [%s] </td></tr>

HTML_NETSTATS_OPERS
	<tr><td>Oprateurs Actuels: </td> <td> %ld </td> <td>Oprateurs Maximum: </td> <td> %ld [%s] </td></tr>

HTML_NETSTATS_SERVERS
	<tr><td>Serveurs Actuels: </td> <td> %ld </td> <td>Serveurs Maximum: </td> <td> %ld [%s] </td></tr>

HTML_NETSTATS_AWAY
	<tr><td colspan="2">Utilisateurs Absents: </td> <td colspan="2"> %ld </td></tr>

HTML_TITLE
	Statistiques Rseau pour %s

HTML_TLD_TITLE
	Statistiques TLD (Top Level Domain)

HTML_TLD_HEADER
	<table><tr><th>Code Pays</th><th>Pays</th><th>Nombre</th><th>De faons gnrale</th></tr>

HTML_TLD_CONTENT
	<tr><td>%s</td><td>%s</td><td>%d</td><td>%d</td></tr>

HTML_TLD_FOOTER
	</table>

HTML_SERVER_HEADER
	<table border=0><tr><th colspan = 2>Nom du Serveur</th></tr>

HTML_SERVER_CONTENT
	<tr><td height="4">Serveur: </td><td height="4"><a href=#%s> %s </a></td></tr>

HTML_SERVER_CONTENT_ONLINE
	<tr><td height="4">Serveur: </td><td height="4"><a href=#%s> %s (*) </a></td></tr>

HTML_SERVER_FOOTER
	</table>(*) indique que le serveur est reli au rseau actuellement<br>(Cliquez sur le nom d'un serveur pour plus d'informations)

HTML_DAILY_HEADER
	<table border = 0><tr><th colspan="4"><b>Statistiques Journalires du Rseau:</b></th></tr>

HTML_DAILY_FOOTER
	</table>

HTML_DAILY_RESET_AT
	<tr><td colspan="4"><center>(Toutes les Statistiques Journalires sont remises  zro  minuit)</center></td></tr>

HTML_DAILY_USER
	<tr><td colspan="2">Utilisateurs Max du jour: </td><td colspan="2"> %ld [%s] </td></tr>

HTML_DAILY_CHAN
	<tr><td colspan="2">Salons Max du jour:</td><td colspan="2"> %ld</td></tr>

HTML_DAILY_OPERS
	<tr><td colspan="2">Oprateurs Max du jour: </td><td colspan="2"> %ld [%s] </td></tr>

HTML_DAILY_SERVERS
	<tr><td colspan="2">Serveurs Max du jour: </td><td colspan="2"> %ld  [%s] </td></tr>

HTML_CTCP_HEADER
	<table border = 0><tr><th>Version</th><th align=right>Nombre</th></tr>

HTML_CTCP_CONTENT
	<tr><td>%s</td><td align=right>%ld</td></tr>	

HTML_CTCP_FOOTER
	</table>

HTML_SERVER_DETAIL_HEADER
	<table border=0><tr><th><a name=%s>Serveur:</th><th colspan = 2><b>%s</b></th></tr>

HTML_SERVER_DETAIL_FOOTER
	</table>

HTML_SERVER_DETAIL_USERS
	<tr><td>Utilisateurs Actuels:</td><td>%ld (%ld)</td><td>Max %ld le [%s]</td></tr>

HTML_SERVER_DETAIL_OPERS
	<tr><td>Oprateurs Actuels:</td><td>%ld (%ld)</td><td>Max %ld le [%s]</td></tr>

HTML_SERVER_DETAIL_CURPING
	<tr><td>Ping Actuel</td><td colspan = 2>%ld</td></tr>

HTML_SERVER_DETAIL_TOTALUSERSEVER
	 <tr><td>Nombre total de connexions:</td><td colspan = 2>%ld</td></tr>

HTML_SERVER_DETAIL_HIGHESTPING
	<tr><td>Plus gros Ping</td><td>%ld</td><td>le [%s]</td></tr>

HTML_SERVER_DETAIL_SPLITS
	<tr><td>Nombre de Splits</td><td colspan = 2>%ld</td></tr>

HTML_SERVER_DETAIL_LAST_SEEN
	<tr><td>Vu la dernire fois:</td><td colspan = 2>[%s]</td></tr>

HTML_SERVER_DETAIL_IRCOPKILLS
	<tr><td>Nombre de Kill des IRCOP</td><td colspan = 2>%ld</td></tr>

HTML_SERVER_DETAIL_SERVERKILLS
	<tr><td>Nombre de KILL du Serveur</td><td colspan = 2>%ld</td></tr>

HTML_CHANNEL_HEADER
	<table border = 0><tr><th>Channel</th><th align=right>Membres</th></tr>

HTML_CHANNEL_CONTENT
	<tr><td>%s</td><td align=right>%ld</td></tr>

HTML_CHANNEL_FOOTER
	</table>

HTML_CHAN_TOP10_HEADER
	<table border = 0><tr><th>Channel</th><th align=right>Nombre d'entres</th></tr>

HTML_CHAN_TOP10_FOOTER
	</table>(*) indicates channel is active at the moment

HTML_CHAN_TOP10_CONTENT
	<tr><td>%s (*)</td><td align=right>%ld</td></tr>

HTML_CHAN_TOP10_OFFLINE
	<tr><td>%s </td><td align=right>%ld</td></tr>

HTML_CHAN_TOP10_KICKS_TITLE
	<b>Top10</b> Salons Fcheux

HTML_CHAN_TOP10_KICKS_HEADER
	<table border = 0><tr><th>Channel</th><th>Nombre de Kicks</th></tr>

HTML_CHAN_TOP10_KICKS_FOOTER
	</table>(*) indique que le salon est ouvert actuellement

HTML_CHAN_TOP10_KICKS_CONTENT
	<tr><td>%s </td><td align=right>%ld</td></tr>

HTML_CHAN_TOP10_KICKS_CONTENT_IN_USE
	<tr><td>%s (*)</td><td align=right>%ld</td></tr>

HTML_TOP10_TOPIC_HEADER
	<table border = 0><tr><th>Channel</th><th>Nombre de Topics</th></tr>

HTML_TOP10_TOPIC_FOOTER
	</table>(*) indicates channel is active at the moment

HTML_TOP10_TOPIC_TITLE
	Top10 Topic Change Channels

HTML_CUR_NETSTATS_TITLE
	Current Network Statistics

HTML_DAILY_TITLE
	Daily Network Statistics

HTML_TOP10_ONLINE_CHANS_TITLE
	Top10 Online Channels

HTML_SERVERLIST_TITLE
	Server List

HTML_TOP10_CHANEVER_TITLE
	Top10 Channels Ever

HTML_SERVERDETAILS_TITLE
	Server Details

HTML_TOP10_CLIENT_TITLE
	Top10 Client Versions

HTML_NETMAP_TITLE
	Network Map

HTML_VERSION
	Version is %s %s

HTML_MOST_UNWELCOME_TITLE
	Most Unwelcome Channels

HTML_POPULAR_TITLE
	Popular Channels

HTML_MOST_TOPIC_TITLE
	Most Topic Channels

HTML_NETSTATS_TITLE
	Network Statistics

NOW_STATS_ADMIN
	%s (%s) est dsormais Administrateur des Stats.

STATS_AUTH_FAILED
	Authentification rate pour %s

STATS_ADMIN_LOGOUT
	%s n'est plus Administrateur des Stats.

SHUTDOWN_SAVING_DB
	Sauvegarde des bases de donnes lors d'un SHUTDOWN, merci de patienter.

CANNOT_OPEN_LOG
	Attention: impossible d'ouvrir le fichier de log: %s

GLOBAL_LOAD_MOD
	%s charge le module %s

GLOBAL_UNLOAD_MOD
	%s dcharge le module %s

GLOBAL_FATAL_ERROR
	ERREUR FATALE! %s: %s

CONFIG_PORT_ERROR
	Le port doit tre un nombre entre 1025 et 65535

CONFIG_HOSTNAME_ERROR
	Dfinition de hostname manquante dans le bloc de connexion.

CONFIG_PROTOCOL_ERROR
	Dfinition de IRCDModule (protocol) manquante dans le bloc de connexion

CONFIG_PORT_ERROR_NOTDEF
	Dfinition de port manquante dans le bloc de connexion

CONFIG_PASSWD_ERROR
	Dfinition de passwd manquante dans le bloc de connexion

CONFIG_PING_TO_LOW
	La frquence de Ping doit tre de 2 minutes ou plus

CONFIG_SQLPING_TO_LOW
	SQL Ping Frequency must be 2 minutes or greater

CONFIG_UPTIME_TO_LOW
	Uptime Frequency must be 2 minutes or greater

CONFIG_DELAYMOD_T0MANY
	Modules retards excessifs (max 128)

CONFIG_TABLE_USER_ERROR
	Dfinition de users manquante dans les blocs "tables"

CONFIG_TABLE_CHANBANS_ERROR
	Dfinition de chanbans manquante dans les blocs "tables"

CONFIG_TABLE_CHANEXCEPT_ERROR
	Dfinition de chanexcept manquante dans les blocs "tables"

CONFIG_TABLE_ISON_ERROR
	Dfinition de ison manquante dans les blocs "tables"

CONFIG_TABLE_SERVER_ERROR
	Dfinition de server manquante dans les blocs "tables"

CONFIG_TABLE_GLINE_ERROR
	Dfinition de gline manquante dans les blocs "tables"

CONFIG_INVALID_LANG
	Langue choisie invalide.

CONFIG_ID_HOST_ERROR
	Dfinition de user (host) manquante dans les blocs d'identification

CONFIG_ID_LANG_ERROR
	Dfinition de language manquante dans les blocs d'identification

CONFIG_ID_USER_ERROR
	Dfinition de user manquante dans les blocs d'identification

CONFIG_ID_DESC_ERROR
	Dfinition de desc manquante dans les blocs d'identification

CONFIG_ID_NAME_ERROR
	Dfinition de name manquante dans les blocs d'identification

CONFIG_ERROR_POSTIVE_VALUE
	Une valeur positive est requise.

CONFIG_SQL_USER_ERROR
	Dfinition de user manquante dans le bloc SQL

CONFIG_SQL_NAME_ERROR
	Dfinition de name manquante dans le bloc SQL

CONFIG_ADMIN_NAME_ERROR
	Dfinition de name manquante dans le bloc admin

CONFIG_ADMIN_HOST_ERROR
	Dfinition de hostname manquante dans le bloc admin

CONFIG_ADMIN_PASS_ERROR
	Dfinition de passwd manquante dans le bloc admin

CONFIG_TIMEOUT_PING_ERROR
	Dfinition de pingfreq manquante dans le bloc de timeout

CONFIG_TIMEOUT_SQL_ERROR
	Lacking sqlfreq definition in timeout block

CONFIG_TIMEOUT_UPTIME_ERROR
	Lacking uptimefreq definition in timeout block

CONFIG_TIMEOUT_HTML_ERROR
	Dfinition de html manquante dans le bloc de timeout

CONFIG_TIMEOUT_UPDATE_ERROR
	Dfinition de update manquante dans le bloc de timeout

CONFIG_TIMEOUT_WARNING_ERROR
	Dfinition de warning manquante dans le bloc de timeout

CONFIG_TIMEOUT_READ_ERROR
	Dfinition de read manquante dans le bloc de timeout

CONFIG_INVALID_TIME
	Ce n'est pas une valeur correcte pour la dure.

CONFIG_HTML_UPDATE_TIME
	Le temps d'update du fichier HTML doit tre de 2 minutes ou plus

CONFIG_NETINFO_NAME_ERROR
	Dfinition de name manquante dans le bloc de netinfo

CONFIG_FILENAME_PID_ERROR
	Dfinition de pid manquante dans le bloc de fichiers

CONFIG_FILENAME_MOTD_ERROR
	Dfinition de motd manquante dans le bloc de fichiers

CONFIG_FILENAME_CHANDB_ERROR
	Dfinition de ChannelDB manquante dans le bloc de fichiers

CONFIG_FILENAME_CTCP_ERROR
	Dfinition de ctcpDB manquante dans le bloc de fichiers

CONFIG_FILENAME_SERVER_ERROR
	Dfinition de ServerDB manquante dans le bloc de fichiers

CONFIG_FILENAME_CHANSTATS_ERROR
	Dfinition de ChannelStatsDB manquante dans le bloc de fichiers

CONFIG_FILENAME_TLD_ERROR
	Dfinition de TLDDB manquante dans le bloc de fichiers

CONFIG_FILENAME_EXCLUDE_ERROR
	Dfinition de EXCLUDEDB manquante dans le bloc de fichiers

CONFIG_SS_DESC_ERROR
	Dfinition de real manquante dans le bloc de statserv

CONFIG_SS_NAME_ERROR
	Dfinition de nick manquante dans le bloc de statserv

CONFIG_SS_TOLONG
	Pseudo trop long

CONFIG_SS_ALIASDESC_ERROR
	Dfinition de aliasreal manquante dans le bloc de statserv

ALOG_FAILED_SQL_CONNECT
	Impossible de se connecter  la base de donnes : %s

ALOG_SQL_ENABLED
	MySQL: has been enabled.

ALOG_SQL_DISABLED
	MySQL: has been disabled.

ALOG_SQL_NOTSET
	MySQL Error: Set all required configuration options.

ALOG_HTML_ERR_WRITE
	Error: unable to accessing file for writing: %s

ALOG_DB_ERROR
	WARNING! DB_READ_ERROR in %s

ALOG_DEBUG_DB_OK
	debug: %s read successfully

ALOG_DEBUG_UNKNOW_CMODE
	debug: unknown mode channel mode %c

ALOG_DEBUG_LAST_LINE
	debug: last line is %s

ALOG_DEBUG_REPORT_AT
	debug: report these to the bugtracker at http://bugtracker.nomadirc.net

ALOG_DEBUG_NONEXISTANT_USER_JOIN
	Channel: received join of non-existing user %s on channel ID %d

ALOG_DEBUG_CHANGE_MODE_CHAN
	debug: Changing modes for %s to %s

AL0G_DEBUG_BAD_CHAN_MODE
	Debug: Malformed mode detected on %s.

ALOG_DEBUG_MODE_NO_PARAM
	channel: mode %c%c with no parameter (?) for channel %s

ALOG_DEBUG_FINDCHAN_BAD
	Error: findchan() called with NULL values

ALOG_DEBUG_FINDSTATCHAN_BAD
	Error: findstatschan() called with NULL values

ALOG_DEBUG_SJOIN_NONEXISTANT
	user: SJOIN for nonexistent user %s on %s

ALOG_DEBUG_JOIN_NONEXISTANT
	user: JOIN for nonexistent user %s on %s

ALOG_DEBUG_JOIN
	debug: %s joins %s

ALOG_DEBUG_KICK_NONEXISTANT
	user: KICK for nonexistent user %s on %s: %s

ALOG_DEBUG_KICKED
	debug: kicking %s from %s

ALOG_DEBUG_PART_NONEXISTANT
	user: PART from nonexistent user %s: %s

ALOG_DEBUG_PART
	debug: %s leaves %s

ALOG_DEBUG_PART_BUG
	user: BUG parting %s: channel entry found but c->chan NULL

ALOG_NON_TS_MODE
	TSMODE enabled but MODE has no valid TS

ALOG_DEBUG_NO_FIND_CHAN
	debug: can't find chan %s

ALOG_DEBUG_TOPIC_TS
	debug: encoded TOPIC TS %s converted to %d

ALOG_TOPIC_NONEXISTANT
	channel: TOPIC %s for nonexistent channel %s

ALOG_ADD_BAN_BAD
	debug: add_ban called with NULL values

ALOG_ADD_BAN_ADDED
	debug: Added ban %s to channel %s

ALOG_ADD_EXCEPTION_ADDED
	debug: Added except %s to channel %s

ALOG_ADD_INVITE_ADDED
	debug: Added invite %s to channel %s

ALOG_CREATE_CHAN
	debug: Creating channel %s

ALOG_DELETE_CHAN
	debug: Deleting channel %s

ALOG_BAN_FREE_ERROR
	channel: BUG freeing %s: bans[%d] is NULL!

ALOG_EXCEPTION_FREE_ERROR
	BUG freeing %s: excepts[%d] is NULL!

ALOG_INVITE_FREE_ERROR
	channel: BUG freeing %s: invite[%d] is NULL!

ALOG_BAN_DEL_CHAN
	debug: Deleted ban %s from channel %s

ALOG_EXCEPTION_DEL_CHAN
	debug: Deleted except %s from channel %s

ALOG_INVITE_DEL_CHAN
	debug: Deleted invite %s from channel %s

ALOG_DEBUG_FLOOD_MODE
	debug: Flood mode for channel %s set to %s

ALOG_NO_FLOOD
	no flood settings

ALOG_KEY_SET_TO
	debug: Key of channel %s set to %s

ALOG_NO_KEY
	no key

ALOG_LIMIT_SET_TO
	debug: Limit of channel %s set to %u

ALOG_REDIRECT_SET_TO
	debug: Redirect of channel %s set to %s

ALOG_NO_REDIRECT
	no redirect

ALOG_DEBUG_BAD_FINDSGROUP
	Error: findsgroup() called with NULL values

ALOG_LARGENET_WARNING_1
	You have selected to run Denora with the least amount of data

ALOG_LARGENET_WARNING_2
	stored in SQL, you should only use this option if you are on a

ALOG_LARGENET_WARNING_3
	very large network of 100,000+ users or have a remote sql database

CONFIG_ERROR_BASE
	Conf Error:  %s near line %d of %s

CONFIG_UNKNOWN_FILE
	unknown

CONFIG_ERROR_OPENING
	Unable to open config file %s

ALOG_DEBUG_RESOLVED_HOST
	debug: Resolved %s to %s

ALOG_DEBUG_BAD_SSTRDUP
	debug: sstrdup() called with NULL-arg

ALOG_RESET_DAILY
	resetting daily stats

ALOG_RESETTING_SUNDAY
	resetting weekly stats (on Sunday)

ALOG_RESETTING_MONDAY
	resetting weekly stats (on Monday)

ALOG_RESETTING_TUESDAY
	resetting weekly stats (on Tuesday)

ALOG_RESETTING_WEDNESDAY
	resetting weekly stats (on Wednesday)

ALOG_RESETTING_THURSDAY
	resetting weekly stats (on Thursday)

ALOG_RESETTING_FRIDAY
	resetting weekly stats (on Friday)

ALOG_RESETTING_SATURDAY
	resetting weekly stats (on Saturday)

ALOG_RESETTING_MONTHLY
	resetting monthly stats

ALOG_TRY_TO_DISPLAY
	debug: trying to display message %s

ALOG_DONE_DISPLAY
	debug: done displaying message %s

ALOG_UKNOWN_USER_MODE
	debug: unknown mode : usermode %c (in %s)

ALOG_SWHOIS_ERROR
	SWHOIS set for nonexistant user %s.

ALOG_VHOST_FOR
	debug: %s changes its vhost to %s

ALOG_REALNAME_FOR
	debug: %s changes its realname to %s

ALOG_USERNAME_FOR
	debug: %s changes its username to %s

ALOG_UMODE_NONEXISTANT
	user: MODE %s for nonexistent nick %s: %s

ALOG_UNKNWON_MSG
	debug: unknown message from server (%s)

ALOG_TRYING_LOAD_MOD
	trying to load [%s]

ALOG_STATUS
	status: [%d]

ALOG_TRYING_UNLOAD_MOD
	trying to unload [%s]

RESTARTING
	Restarting

RESTART_FAILED
	Restart failed

SAVING_FFF
	debug: Saving FFF information to disk

ALOG_SIGPIPE_WARNING
	Denora will execute a backtrace, and continue on, however Denora may become unstable

ALOG_NO_STATS_BIN
	Restart attempt failed--STATS_BIN not defined (rerun configure)

ALOG_ERR_REHASH_NO_MEM
	Error during the reload of the configuration file, but out of memory!

ALOG_ERR_REHASH
	Error Reading Configuration File (Received SIGHUP)

BACKTRACE_LINES
	Backtrace: report the following lines

BACKTRACE_NOT_HERE
	Backtrace: not available on this platform - use GDB

ALOG_DEBUG_SERVINTRO
	debug: Server introduced (%s)

ALOG_DEBUG_SERVINTRO_FORM
	debug: Server introduced (%s) from %s

ALOG_DEBUG_PINGTIME
	debug: Ping Time from %s : %ld = %ld - %ld

ALOG_ERR_FINDSERVER
	debug: Error: findserver() called with NULL values

ALOG_ERR_FINDSERVERSTATS
	Error: findserverstats() called with NULL values

ALOG_ERR_FINDSERVERSUID
	Error: findserver_suid() called with NULL values

ALOG_ERR_DEL_SERVSTATS
	Error: delete_serverstats() called with NULL values

ALOG_DEL_SERVSTATS_FOR
	debug: delete_serverstats() called for %s

ALOG_DEL_SERVSTATS_DONE
	debug: delete_serverstats() completed

ALOG_ERR_DEL_SERVER
	Error: delete_server() called with NULL values

ALOG_DEL_SERVER_FOR
	debug: delete_server() called for %s

ALOG_DEL_SERVER_NOQUIT
	debug: delete_server() cleared all users for NOQUIT

ALOG_DEL_SERVER_DONE
	debug: delete_server() completed

ALOG_DEBUG_UNKNOWN_VERSION_REPLY
	debug: sql_do_server_version received unknown version format

ALOG_MOD_TRY_LOAD
	trying to load [%s]

ALOG_MOD_STATUS
	status: [%d]

ALOG_MOD_ERROR
	Module error: %s

ALOG_MOD_BE_ONLY_ONE
	You cannot have 2 protocol modules loaded.

ALOG_MOD_UNLOAD_SELF
	debug: %s requested unload...

ALOG_CMD_DISPLAY_START
	debug: trying to display command %s

ALOG_CMD_DISPLAY_END
	debug: done displaying command %s

ALOG_CMD_DISPLAY_LIST
	debug: Displaying command list for %s

ALOG_MSG_DISPLAY_START
	debug: trying to display message %s

ALOG_MSG_DISPLAY_END
	debug: done displaying message %s

ALOG_MSG_DISPLAY_LIST
	debug: Displaying message list for %s

ALOG_MOD_CALLBACK_DISPLAY
	debug: Added module CallBack: [%s] due to execute at %ld
