/* StatServ core functions
 *
 * (C) 2003-2005 Anope Team
 * Contact us at info@anope.org
 *
 * Please read COPYING and README for further details.
 *
 * Based on the original code of Epona by Lara.
 * Based on the original code of Services by Andy Church. 
 * 
 * $Id: ss_help.c 389 2005-07-05 22:45:48Z trystan $
 *
 */
/*************************************************************************/

#include "denora.h"

static int do_help(User * u);
int DenoraInit(int argc, char **argv);
void DenoraFini(void);

/**
 * Create the command, and tell anope about it.
 * @param argc Argument count
 * @param argv Argument list
 * @return MOD_CONT to allow the module, MOD_STOP to stop it
 **/
int DenoraInit(int argc, char **argv)
{
    Command *c;

    if (denora->debug >= 2) {
        protocol_debug(NULL, argc, argv);
    }
    moduleAddAuthor("Denora");
    moduleAddVersion("$Id: ss_help.c 389 2005-07-05 22:45:48Z trystan $");
    moduleSetType(CORE);

    c = createCommand("HELP",      do_help,       is_oper,             -1, -1,-1,-1);
    moduleAddCommand(STATSERV, c, MOD_UNIQUE);

    return MOD_CONT;
}

/**
 * Unload the module
 **/
void DenoraFini(void)
{

}

/*************************************************************************/

/* HELP command. */

static int do_help(User * u)
{
    const char *cmd = strtok(NULL, "");

    SET_SEGV_LOCATION();

    if (!cmd) {
        notice_help(s_StatServ, u, STAT_HELP);
#ifdef USE_MODULES
        if (is_stats_admin(u))
            notice_help(s_StatServ, u, STAT_HELP_ADMIN_CMD);
#endif
        moduleDisplayHelp(5, u);
    } else {
        mod_help_cmd(s_StatServ, u, STATSERV, cmd);
    }
    return MOD_CONT;
}

/*************************************************************************/


