/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: cron.c 415 2005-07-14 01:10:35Z trystan $
 *
 */
#include "denora.h"

time_t lastrun = 0;
CronEventHash *CRONEVENT[MAX_CMD_HASH];

/*************************************************************************/

void denora_cron(time_t ts)
{
    static struct tm *cron_time;

    /* so it should run at least every few mins (PING) */
    cron_time = localtime(&ts);

    if ((ts - lastrun) <= 3600) {       /* stop if lastrun is within the last 60 minutes  */
        return;                 /* cstats_cron is called on each socket activity, */
    }
    SET_SEGV_LOCATION();

    if (cron_time->tm_hour == 0) {      /* midnight */
        /* run midnight routines */
        alog(LOG_NORMAL, langstr(ALOG_RESET_DAILY));

        cron_process_events(CRON_MIDNIGHT);

        if (cron_time->tm_wday == 0) {  /* sunday midnight */
            /* run weekly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_SUNDAY));
            cron_process_events(CRON_WEEKLY_SUNDAY);
        }
        if (cron_time->tm_wday == 1) {  /* monday midnight */
            /* run weekly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_MONDAY));
            cron_process_events(CRON_WEEKLY_MONDAY);
        }
        if (cron_time->tm_wday == 2) {  /* tuesday midnight */
            /* run weekly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_TUESDAY));
            cron_process_events(CRON_WEEKLY_TUESDAY);
        }
        if (cron_time->tm_wday == 3) {  /* Wednesday midnight */
            /* run weekly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_WEDNESDAY));
            cron_process_events(CRON_WEEKLY_WEDNESDAY);
        }
        if (cron_time->tm_wday == 4) {  /* Thursday midnight */
            /* run weekly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_THURSDAY));
            cron_process_events(CRON_WEEKLY_THURSDAY);
        }
        if (cron_time->tm_wday == 5) {  /* tuesday midnight */
            /* run weekly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_FRIDAY));
            cron_process_events(CRON_WEEKLY_FRIDAY);
        }
        if (cron_time->tm_wday == 6) {  /* Saturday midnight */
            /* run weekly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_SATURDAY));
            cron_process_events(CRON_WEEKLY_SATURDAY);
        }
        if (cron_time->tm_mday == 1) {  /* 1st day of month midnight */
            /* run monthly routines */
            alog(LOG_NORMAL, langstr(ALOG_RESETTING_MONTHLY));
            cron_process_events(CRON_MONTHLY);
        }
        SET_SEGV_LOCATION();
    } else if (cron_time->tm_hour == 1) {
        cron_process_events(CRON_HOUR_1);
    } else if (cron_time->tm_hour == 2) {
        cron_process_events(CRON_HOUR_2);
    } else if (cron_time->tm_hour == 3) {
        cron_process_events(CRON_HOUR_3);
    } else if (cron_time->tm_hour == 4) {
        cron_process_events(CRON_HOUR_4);
    } else if (cron_time->tm_hour == 5) {
        cron_process_events(CRON_HOUR_5);
    } else if (cron_time->tm_hour == 6) {
        cron_process_events(CRON_HOUR_6);
    } else if (cron_time->tm_hour == 7) {
        cron_process_events(CRON_HOUR_7);
    } else if (cron_time->tm_hour == 8) {
        cron_process_events(CRON_HOUR_8);
    } else if (cron_time->tm_hour == 9) {
        cron_process_events(CRON_HOUR_9);
    } else if (cron_time->tm_hour == 10) {
        cron_process_events(CRON_HOUR_10);
    } else if (cron_time->tm_hour == 11) {
        cron_process_events(CRON_HOUR_11);
    } else if (cron_time->tm_hour == 12) {
        cron_process_events(CRON_HOUR_12);
    } else if (cron_time->tm_hour == 13) {
        cron_process_events(CRON_HOUR_13);
    } else if (cron_time->tm_hour == 14) {
        cron_process_events(CRON_HOUR_14);
    } else if (cron_time->tm_hour == 15) {
        cron_process_events(CRON_HOUR_15);
    } else if (cron_time->tm_hour == 16) {
        cron_process_events(CRON_HOUR_16);
    } else if (cron_time->tm_hour == 17) {
        cron_process_events(CRON_HOUR_17);
    } else if (cron_time->tm_hour == 18) {
        cron_process_events(CRON_HOUR_18);
    } else if (cron_time->tm_hour == 19) {
        cron_process_events(CRON_HOUR_19);
    } else if (cron_time->tm_hour == 20) {
        cron_process_events(CRON_HOUR_20);
    } else if (cron_time->tm_hour == 21) {
        cron_process_events(CRON_HOUR_21);
    } else if (cron_time->tm_hour == 22) {
        cron_process_events(CRON_HOUR_22);
    } else if (cron_time->tm_hour == 23) {
        cron_process_events(CRON_HOUR_23);
        /* hourly with a three min window */
    } else if (cron_time->tm_hour >= 0) {
        cron_process_events(CRON_HOURLY);
    }
    lastrun = ts;
}

/*************************************************************************/

void cron_process_events(const char *name)
{
    int retVal = 0;
    CronEvent *current = NULL;
    CronEvent *evh;

    SET_SEGV_LOCATION();

    /* Do something with the message. */
    evh = findCronEvent(CRONEVENT, name);
    if (evh) {
        if (evh->func) {
            retVal = evh->func(name);
            if (retVal == MOD_CONT) {
                current = evh->next;
                while (current && current->func && retVal == MOD_CONT) {
                    retVal = current->func(name);
                    current = current->next;
                }
            }
        }
    }
    SET_SEGV_LOCATION();
}

/*************************************************************************/

CronEvent *createCronEvent(const char *name,
                           int (*func) (const char *name))
{
    CronEvent *evm = NULL;
    if (!func) {
        return NULL;
    }
    SET_SEGV_LOCATION();

    if ((evm = malloc(sizeof(CronEvent))) == NULL) {
        fatal("Out of memory!");
    }
    evm->name = sstrdup(name);
    evm->func = func;
    evm->next = NULL;
    return evm;
}

/*************************************************************************/

CronEvent *findCronEvent(CronEventHash * hookEvtTable[], const char *name)
{
    int idx;
    CronEventHash *current = NULL;
    if (!hookEvtTable || !name) {
        return NULL;
    }
    SET_SEGV_LOCATION();

    idx = CMD_HASH(name);

    for (current = hookEvtTable[idx]; current; current = current->next) {
        if (stricmp(name, current->name) == 0) {
            return current->evh;
        }
    }
    return NULL;
}

/*************************************************************************/

int addCronEvent(CronEventHash * hookEvtTable[], CronEvent * evh)
{
    /* We can assume both param's have been checked by this point.. */
    int cronindex = 0;
    CronEventHash *current = NULL;
    CronEventHash *newHash = NULL;
    CronEventHash *lastHash = NULL;

    if (!hookEvtTable || !evh) {
        return MOD_ERR_PARAMS;
    }
    SET_SEGV_LOCATION();

    cronindex = CMD_HASH(evh->name);

    for (current = hookEvtTable[cronindex]; current;
         current = current->next) {
        if (stricmp(evh->name, current->name) == 0) {   /* the msg exist's we are a addHead */
            evh->next = current->evh;
            current->evh = evh;
            alog(LOG_DEBUG,
                 "debug: existing Cron: (0x%p), new msg (0x%p) (%s)",
                 (void *) evh->next, (void *) evh, evh->name);
            return MOD_ERR_OK;
        }
        lastHash = current;
    }

    if ((newHash = malloc(sizeof(CronEventHash))) == NULL) {
        fatal("Out of memory");
    }
    newHash->next = NULL;
    newHash->name = sstrdup(evh->name);
    newHash->evh = evh;
    SET_SEGV_LOCATION();

    if (lastHash == NULL)
        hookEvtTable[cronindex] = newHash;
    else
        lastHash->next = newHash;
    return MOD_ERR_OK;
}

/*************************************************************************/

/**
 * Destory a message, freeing its memory.
 * @param m the message to be destroyed
 * @return MOD_ERR_SUCCESS on success
 **/
int destroyCronEvent(CronEvent * evh)
{
    if (!evh) {
        return MOD_ERR_PARAMS;
    }
    SET_SEGV_LOCATION();

    if (evh->name) {
        denora_free(evh->name);
    }
    evh->func = NULL;
    if (evh->mod_name) {
        denora_free(evh->mod_name);
    }
    evh->next = NULL;
    return MOD_ERR_OK;
}

/*************************************************************************/

int delCronEvent(CronEventHash * msgEvtTable[], CronEvent * evm,
                 char *mod_name)
{
    int cronindex = 0;
    CronEventHash *current = NULL;
    CronEventHash *lastHash = NULL;
    CronEvent *tail = NULL, *last = NULL;

    if (!evm || !msgEvtTable) {
        return MOD_ERR_PARAMS;
    }
    SET_SEGV_LOCATION();

    cronindex = CMD_HASH(evm->name);

    for (current = msgEvtTable[cronindex]; current;
         current = current->next) {
        if (stricmp(evm->name, current->name) == 0) {
            if (!lastHash) {
                tail = current->evh;
                if (tail->next) {
                    while (tail) {
                        if (mod_name && tail->mod_name
                            && (stricmp(mod_name, tail->mod_name) == 0)) {
                            if (last) {
                                last->next = tail->next;
                            } else {
                                current->evh = tail->next;
                            }
                            return MOD_ERR_OK;
                        }
                        last = tail;
                        tail = tail->next;
                    }
                } else {
                    msgEvtTable[cronindex] = current->next;
                    denora_free(current->name);
                    return MOD_ERR_OK;
                }
            } else {
                tail = current->evh;
                if (tail->next) {
                    while (tail) {
                        if (mod_name && tail->mod_name
                            && (stricmp(mod_name, tail->mod_name) == 0)) {
                            if (last) {
                                last->next = tail->next;
                            } else {
                                current->evh = tail->next;
                            }
                            return MOD_ERR_OK;
                        }
                        last = tail;
                        tail = tail->next;
                    }
                } else {
                    lastHash->next = current->next;
                    denora_free(current->name);
                    return MOD_ERR_OK;
                }
            }
        }
        lastHash = current;
    }
    SET_SEGV_LOCATION();

    return MOD_ERR_NOEXIST;
}

/*************************************************************************/

int moduleCronEventDel(const char *name)
{
    CronEvent *evh;
    int status;

    if (!mod_current_module) {
        return MOD_ERR_UNKNOWN;
    }
    evh = findCronEvent(CRONEVENT, name);
    if (!evh) {
        return MOD_ERR_NOEXIST;
    }
    SET_SEGV_LOCATION();

    status = delCronEvent(CRONEVENT, evh, mod_current_module->name);
    if (denora->debug) {
        displayCronFromHash(evh->name);
    }
    return status;
}

/*************************************************************************/

int moduleAddCronEvent(CronEvent * evh)
{
    int status;

    if (!evh) {
        return MOD_ERR_PARAMS;
    }
    SET_SEGV_LOCATION();

    if ((mod_current_module_name) && (!mod_current_module)) {
        mod_current_module = findModule(mod_current_module_name);
    }

    if (!mod_current_module) {
        return MOD_ERR_UNKNOWN;
    }                           /* shouldnt happen */
    evh->core = 0;
    if (!evh->mod_name) {
        evh->mod_name = sstrdup(mod_current_module->name);
    }
    SET_SEGV_LOCATION();

    status = addCronEvent(CRONEVENT, evh);
    if (denora->debug) {
        displayCronFromHash(evh->name);
    }
    return status;
}

/*************************************************************************/

int addCoreCronEvent(CronEventHash * hookEvtTable[], CronEvent * evh)
{
    if (!hookEvtTable || !evh) {
        return MOD_ERR_PARAMS;
    }
    SET_SEGV_LOCATION();

    evh->core = 1;
    return addCronEvent(hookEvtTable, evh);
}

/*************************************************************************/

int displayCronFromHash(char *name)
{
    CronEventHash *current = NULL;
    int cronindex = 0;
    cronindex = CMD_HASH(name);

    alog(LOG_EXTRADEBUG, langstr(ALOG_TRY_TO_DISPLAY), name);
    SET_SEGV_LOCATION();

    for (current = CRONEVENT[cronindex]; current; current = current->next) {
        if (stricmp(name, current->name) == 0) {
            displayCronEvent(current->evh);
        }
    }
    alog(LOG_EXTRADEBUG, langstr(ALOG_DONE_DISPLAY), name);
    return 0;
}

/*************************************************************************/

int displayCronEvent(CronEvent * evh)
{
    CronEvent *msg = NULL;
    int i = 0;
    alog(LOG_EXTRADEBUG, "debug: Displaying message list for %s",
         evh->name);
    for (msg = evh; msg; msg = msg->next) {
        alog(LOG_DEBUG, "%d: 0x%p", ++i, (void *) msg);
    }
    SET_SEGV_LOCATION();

    alog(LOG_EXTRADEBUG, "debug: end");
    return 0;
}

/*************************************************************************/

void setup_cron_event()
{
    CronEvent *evt;
    evt = createCronEvent(CRON_MIDNIGHT, chanstats_daily);
    addCronEvent(CRONEVENT, evt);
    evt = createCronEvent(CRON_WEEKLY_MONDAY, chanstats_weekly);
    addCronEvent(CRONEVENT, evt);
    evt = createCronEvent(CRON_MONTHLY, chanstats_month);
    addCronEvent(CRONEVENT, evt);
    evt = createCronEvent(CRON_MIDNIGHT, users_daily);
    addCronEvent(CRONEVENT, evt);
    evt = createCronEvent(CRON_HOURLY, users_hourly);
    addCronEvent(CRONEVENT, evt);
    evt = createCronEvent(CRON_HOURLY, chans_hourly);
    addCronEvent(CRONEVENT, evt);
}
