
/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: numerics.c 425 2005-07-23 04:45:20Z trystan $
 *
 */

#include "denora.h"

/*************************************************************************/

/* 372 */
void denora_cmd_372(char *source, char *msg)
{
    SET_SEGV_LOCATION();

    if (ircd->numerics) {
        if (ircd->p10) {
            send_cmd(p10id, "372 %s :- %s", source, msg);
        } else if (ircd->ts6 && UseTS6) {
            send_cmd((TS6SID ? TS6SID : ServerName), "372 %s :- %s", source, msg);
        } else {
            send_cmd(ServerName, "372 %s :- %s", source, msg);
        }
    }
}

/*************************************************************************/

void denora_cmd_422(char *source)
{
    SET_SEGV_LOCATION();

    if (ircd->numerics) {
        if (ircd->p10) {
            send_cmd(p10id, "422 %s :MOTD file not found!", source);
        } else if (ircd->ts6 && UseTS6) {
            send_cmd((TS6SID ? TS6SID : ServerName), "422 %s :MOTD file not found!", source);
        } else {
            send_cmd(ServerName, "422 %s :MOTD file not found!", source);
        }
    }
}

/*************************************************************************/

void denora_cmd_375(char *source)
{
    SET_SEGV_LOCATION();

    if (ircd->numerics) {
        if (ircd->p10) {
            send_cmd(p10id, "375 %s :- %s Message of the Day",
                 source, ServerName);
        } else if (ircd->ts6 && UseTS6) {
            send_cmd((TS6SID ? TS6SID : ServerName), "375 %s :- %s Message of the Day",
                 source, ServerName);
        } else {
            send_cmd(ServerName, "375 %s :- %s Message of the Day",
                 source, ServerName);
        }
    }
}

/*************************************************************************/

void denora_cmd_376(char *source)
{
    SET_SEGV_LOCATION();

   if (ircd->numerics) {
        if (ircd->p10) {
            send_cmd(p10id, "376 %s :End of /MOTD command.", source);
        } else if (ircd->ts6 && UseTS6) {
            send_cmd((TS6SID ? TS6SID : ServerName), "376 %s :End of /MOTD command.", source);
        } else {
            send_cmd(ServerName, "376 %s :End of /MOTD command.", source);
        }
    }
}

/*************************************************************************/

/* 391    RPL_TIME ":%s 391 %s %s :%s" */
void denora_cmd_391(char *source, char *timestr)
{
    SET_SEGV_LOCATION();

    if (!timestr) {
        return;
    }
    if (ircd->numerics) {
        if (ircd->p10) {
            send_cmd(p10id, "391 %s %s :%s", source, ServerName, timestr);
        } else if (ircd->ts6 && UseTS6) {
            send_cmd((TS6SID ? TS6SID : ServerName), "391 %s %s :%s", source, ServerName, timestr);
        } else {
            send_cmd(ServerName, "391 %s %s :%s", source, ServerName, timestr);
        }
    }
}

/*************************************************************************/

/* 219 */
void denora_cmd_219(char *source, char *letter)
{
    SET_SEGV_LOCATION();

    if (!source) {
        return;
    }

    if (ircd->numerics) {
     if (letter) {
        if (ircd->p10) {
            send_cmd(p10id, "219 %s %c :End of /STATS report.", source,
                 *letter);
        } else if (ircd->ts6 && UseTS6) {
            send_cmd((TS6SID ? TS6SID : ServerName), "219 %s %c :End of /STATS report.", source,
                 *letter);
        } else {
            send_cmd(NULL, "219 %s %c :End of /STATS report.", source,
                 *letter);
        }
     } else {
        if (ircd->p10) {
            send_cmd(p10id, "219 %s l :End of /STATS report.", source);
        } else if (ircd->ts6 && UseTS6) {
            send_cmd((TS6SID ? TS6SID : ServerName), "219 %s l :End of /STATS report.", source);
        } else {
            send_cmd(NULL, "219 %s l :End of /STATS report.", source);
        }
     }
    }
}

/*************************************************************************/

/* 401 */
void denora_cmd_401(char *source, char *who)
{
    SET_SEGV_LOCATION();

    if (!source || !who) {
        return;
    }
    if (ircd->numerics) {
     if (ircd->p10) {
        send_cmd(p10id, "401 %s %s :No such service.", source, who);
     } else if (ircd->ts6 && UseTS6) {
         send_cmd((TS6SID ? TS6SID : ServerName), "401 %s %s :No such service.", source, who);
     } else {
        send_cmd(ServerName, "401 %s %s :No such service.", source, who);
     }
    }
}

/*************************************************************************/

/* 318 */
void denora_cmd_318(char *source, char *who)
{
    SET_SEGV_LOCATION();

    if (!source || !who) {
        return;
    }
    if (ircd->numerics) {
     if (ircd->p10) {
        send_cmd(p10id, "318 %s %s :End of /WHOIS list.", source, who);
     } else if (ircd->ts6 && UseTS6) {
        send_cmd((TS6SID ? TS6SID : ServerName), "318 %s %s :End of /WHOIS list.", source, who);
     } else {
        send_cmd(ServerName, "318 %s %s :End of /WHOIS list.", source, who);
     }
    }
}

/*************************************************************************/

void denora_cmd_numeric(int numeric, const char *fmt, ...)
{
    va_list args;
    char buf[BUFSIZE];
    *buf = '\0';

    SET_SEGV_LOCATION();

    if (fmt) {
        va_start(args, fmt);
        vsnprintf(buf, BUFSIZE - 1, fmt, args);
        va_end(args);
    }
    if (!buf) {
        return;
    }

    if (ircd->numerics) {
      if (ircd->p10) {
        send_cmd(p10id, "%d %s", numeric, buf);
      } else if (ircd->ts6 && UseTS6) {
        send_cmd((TS6SID ? TS6SID : NULL), "%d %s", numeric, buf);
      } else {
        send_cmd(NULL, "%d %s", numeric, buf);
      }
    }
}

/*************************************************************************/

int denora_event_246(char *source, int ac, char **av)
{
    SET_SEGV_LOCATION();

    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }

    if (ac >= 3) {
     if (denora_get_ircd() == IRC_SOLIDIRCD) {
         sql_uline(av[4]);
     } else if (denora_get_ircd() == IRC_VIAGRA) {
        sql_uline(av[2]);
     } else if (denora_get_ircd() == IRC_BAHAMUT) {
        sql_uline(av[4]);
     } else if (denora_get_ircd() == IRC_FQIRCD) {
        sql_uline(av[4]);
     } else if (denora_get_ircd() == IRC_ULTIMATE3) {
        sql_uline(av[2]);
     } else if (denora_get_ircd() == IRC_LIQUIDIRCD) {
        sql_uline(av[2]);
     }
    }
    return MOD_CONT;
}

/*************************************************************************/

int denora_event_248(char *source, int ac, char **av)
{
    SET_SEGV_LOCATION();

  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }

    if (ac >= 3) {
      sql_uline(av[2]);
    }
    return MOD_CONT;
}

/*************************************************************************/

int denora_event_372(char *source, int ac, char **av)
{
    SET_SEGV_LOCATION();
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac >= 2) {
      sql_motd_store(source, av[1]);
    }
    return MOD_CONT;
}

/*************************************************************************/

int denora_event_242(char *source, int ac, char **av)
{
     if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac >= 2) {
     sql_do_uptime(source, av[1]);
    }
    return MOD_CONT;
}

/*************************************************************************/

int denora_event_351(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    sql_do_server_version(source, ac, av);
    return MOD_CONT;
}

/*************************************************************************/

int denora_event_375(char *source, int ac, char **av)
{
    SET_SEGV_LOCATION();
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    rdb_query("UPDATE %s SET motd=\"\" WHERE server=\"%s\"", ServerTable, source);
    return MOD_CONT;
}

/*************************************************************************/


