/* IrcDreams P10 IRCD
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 *
 * $Id: ircdreams.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

#define IRC_UMODE_a 0x00000001  /* umode +a - Admin */
#define IRC_UMODE_c 0x00000002  /* umode +c - CoAdmin */
#define IRC_UMODE_i 0x00000004  /* umode +i - Invisible */
#define IRC_UMODE_o 0x00000008  /* umode +o - Oper */
#define IRC_UMODE_r 0x00000010  /* umode +r - registered nick */
#define IRC_UMODE_w 0x00000020  /* umode +w - Get wallops */
#define IRC_UMODE_x 0x00000080  /* umode +x - Squelch with notice */
#define IRC_UMODE_A 0x00000100  /* umode +A - Helper */
#define IRC_UMODE_D 0x00000200  /* umode +D - Restart? */
#define IRC_UMODE_f 0x00000400  /* umode +f - Female */
#define IRC_UMODE_h 0x00000800  /* umode +h - Male */
#define IRC_UMODE_O 0x00001000  /* umode +O - Local Oper */
#define IRC_UMODE_s 0x00002000  /* umode +s - Server notices */
#define IRC_UMODE_H 0x00004000  /* umode +H - ??? */
#define IRC_UMODE_k 0x00008000  /* umode +k - Server kill messages */
#define IRC_UMODE_Z 0x00010000  /* umode +Z - Protect?? */
#define IRC_UMODE_C 0x00020000  /* umode +C - No Chan? */
#define IRC_UMODE_d 0x00040000  /* umode +d - deaf */
#define IRC_UMODE_g 0x00080000  /* umode +g - debug */
#define IRC_UMODE_I 0x00100000  /* umode +I - No Idle?? */
#define IRC_UMODE_R 0x00200000  /* umode +R - ? */
#define IRC_UMODE_P 0x00400000  /* umode +P - ? */
#define IRC_UMODE_W 0x00800000  /* umode +W - ? */
#define IRC_UMODE_X 0x01000000  /* umode +X - ?? */


/* ispmtcdCDNu */
#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040	/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_c 0x00000100
#define IRCD_CMODE_r 0x00000200
#define IRCD_CMODE_C 0x00000400
#define IRCD_CMODE_O 0x00000800
#define IRCD_CMODE_N 0x00001000
#define IRCD_CMODE_q 0x00002000
#define IRCD_CMODE_R 0x00004000
#define IRCD_CMODE_T 0x00008000
#define IRCD_CMODE_P 0x00010000
#define IRCD_CMODE_W 0x00020000
#define IRCD_CMODE_M 0x00040000
#define IRCD_CMODE_D 0x00080000

void ircdreams_cmd_nick(char *nick, char *name, const char *modes);
void ircdreams_cmd_mode(char *source, char *dest, char *buf);
void ircdreams_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void ircdreams_cmd_notice(char *source, char *dest, char *buf);
void ircdreams_cmd_privmsg(char *source, char *dest, char *buf);
void ircdreams_cmd_serv_notice(char *source, char *dest, char *msg);
void ircdreams_cmd_serv_privmsg(char *source, char *dest, char *msg);
void ircdreams_cmd_351(char *source);
void ircdreams_cmd_quit(char *source, char *buf);
void ircdreams_cmd_pong(char *servname, char *who);
void ircdreams_cmd_join(char *user, char *channel, time_t chantime);
void ircdreams_cmd_server(char *servname, int hop, char *descript);
void ircdreams_cmd_part(char *nick, char *chan, char *buf);
void ircdreams_cmd_global(char *source, char *buf);
void ircdreams_cmd_squit(char *servname, char *message);
void ircdreams_cmd_connect(void);
void ircdreams_cmd_eob(void);
void ircdreams_cmd_capab(void);
void ircdreams_cmd_ctcp(char *source, char *dest, char *buf);
void ircdreams_cmd_pass(char *pass);
void ircdreams_cmd_version(char *server);
void ircdreams_cmd_stats(char *sender, const char *letter, char *server);
void ircdreams_cmd_motd(char *sender, char *server);
void ircdreams_cmd_ping(char *server);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_gnotice(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_eob(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_create(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);
int denora_event_sgline(char *source, int ac, char **av);
int denora_event_chghost(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
