/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: sorcery.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

#define IRC_UMODE_a 0x00000001
#define IRC_UMODE_h 0x00000002
#define IRC_UMODE_i 0x00000004
#define IRC_UMODE_o 0x00000008
#define IRC_UMODE_r 0x00000010
#define IRC_UMODE_w 0x00000020
#define IRC_UMODE_A 0x00000040
#define IRC_UMODE_m 0x00000080
#define IRC_UMODE_p 0x04000000
#define IRC_UMODE_R 0x08000000
#define IRC_UMODE_P 0x20000000
#define IRC_UMODE_g 0x80000000
#define IRC_UMODE_x 0x40000000


#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040		/* These two used only by ChanServ */
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_f 0x00000400
#define IRCD_CMODE_r 0x00000200		/* Set for all registered channels */

void sorcery_cmd_nick(char *nick, char *name, const char *modes);
void sorcery_cmd_mode(char *source, char *dest, char *buf);
void sorcery_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void sorcery_cmd_notice(char *source, char *dest, char *buf);
void sorcery_cmd_privmsg(char *source, char *dest, char *buf);
void sorcery_cmd_serv_notice(char *source, char *dest, char *msg);
void sorcery_cmd_serv_privmsg(char *source, char *dest, char *msg);
void sorcery_cmd_351(char *source);
void sorcery_cmd_quit(char *source, char *buf);
void sorcery_cmd_pong(char *servname, char *who);
void sorcery_cmd_join(char *user, char *channel, time_t chantime);
void sorcery_cmd_part(char *nick, char *chan, char *buf);
void sorcery_cmd_global(char *source, char *buf);
void sorcery_cmd_squit(char *servname, char *message);
void sorcery_cmd_connect(void);
void sorcery_cmd_eob(void);
void sorcery_cmd_ctcp(char *source, char *dest, char *buf);
void sorcery_cmd_version(char *server);
void sorcery_cmd_stats(char *sender, const char *letter, char *server);
void sorcery_cmd_motd(char *sender, char *servr);
void sorcery_cmd_ping(char *server);
void sorcery_cmd_pass(char *pass);
void sorcery_cmd_server(char *servname, int hop, char *descript);
void sorcery_cmd_capab(void);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_gnotice(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_svinfo(char *source, int ac, char **av);
int denora_event_chghost(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_chgident(char *source, int ac, char **av);
int denora_event_setident(char *source, int ac, char **av);
int denora_event_chgname(char *source, int ac, char **av);
int denora_event_setname(char *source, int ac, char **av);
int denora_event_svsinfo(char *source, int ac, char **av);
int denora_event_snick(char *source, int ac, char **av);
int denora_event_vhost(char *source, int ac, char **av);
int denora_event_tkl(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_netctrl(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_snotice(char *source, int ac, char **av);
int denora_event_umode2(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_swhois(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_sdesc(char *source, int ac, char **av);
int denora_event_sqline(char *source, int ac, char **av);
int denora_event_sgline(char *source, int ac, char **av);
int denora_event_akill(char *source, int ac, char **av);
int denora_event_rakill(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
