/* Unreal IRCD 3.1.x functions
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 *
 * $Id: unreal31.c 433 2005-07-26 16:58:24Z drstein $
 *
 */

/*************************************************************************/

#include "denora.h"
#include "unreal31.h"

IRCDVar myIrcd[] = {
    {"UnrealIRCd 3.2.x",        /* ircd name */
     "+ioS",                    /* operserv mode */
     1,                         /* Vhost  */
     1,                         /* Supports SGlines     */
     0,                         /* sgline sql table */
     1,                         /* Supports SQlines     */
     0,                         /* sqline sql table */
     1,                         /* Supports SZlines     */
     1,                         /* Has exceptions +e    */
     1,                         /* vidents              */
     0,                         /* NICKIP               */
     1,                         /* VHOST ON NICK        */
     1,                         /* +f                   */
     1,                         /* +L                   */
     IRCD_CMODE_f,                   /* +f Mode                          */
     IRCD_CMODE_L,                   /* +L Mode                          */
     NULL,                      /* CAPAB Chan Modes             */
     1,                         /* We support Unreal TOKENS */
     0,                         /* TOKENS are CASE Sensitive */
     1,                         /* TIME STAMPS are BASE64 */
     0,                         /* +I support */
     '&',                       /* SJOIN ban char */
     '\"',                      /* SJOIN except char */
     IRC_UMODE_x,
     1,
     1,
     1,
     "adghiopqrtvwxzABCDGHNRSTVW",
     "beIovahqcfijklmnprstuyzACDGHKLMNOQRSTV",
     'f',
     0,
     'x',
     't',
     0,
     0,
     1,
     0,
     0,
     'b',
     'e',
     0,
     0,
     1,
     NULL,
     1},
};


IRCDCAPAB myIrcdcap[] = {
    {
     CAPAB_NOQUIT,              /* NOQUIT       */
     0,                         /* TSMODE       */
     0,                         /* UNCONNECT    */
     0,                         /* NICKIP       */
     0,                         /* SJOIN        */
     CAPAB_ZIP,                 /* ZIP          */
     0,                         /* BURST        */
     0,                         /* TS5          */
     0,                         /* TS3          */
     0,                         /* DKEY         */
     0,                         /* PT4          */
     0,                         /* SCS          */
     0,                         /* QS           */
     0,                         /* UID          */
     0,                         /* KNOCK        */
     0,                         /* CLIENT       */
     0,                         /* IPV6         */
     0,                         /* SSJ5         */
     0,                         /* SN2          */
     CAPAB_TOKEN,               /* TOKEN        */
     0,                         /* VHOST        */
     CAPAB_SSJ3,                /* SSJ3         */
     CAPAB_NICK2,               /* NICK2        */
     CAPAB_UMODE2,              /* UMODE2       */
     CAPAB_VL,                  /* VL           */
     CAPAB_TLKEXT,              /* TLKEXT       */
     0,                         /* DODKEY       */
     0,                         /* DOZIP        */
     0,
     0,
     0,
     }
};

unsigned long myumodes[128] = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, IRC_UMODE_A, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,
    0,
    0,
    0, 0, 0, 0, 0, 0, 0,
    0,
    0, 0, 0, 0, 0,
    0, IRC_UMODE_a, 0, 0, 0, 0, 0,
    IRC_UMODE_g,
    IRC_UMODE_h, IRC_UMODE_i, 0, 0, 0, 0, 0, IRC_UMODE_o,
    0,
    0, IRC_UMODE_r, 0, 0, 0, 0, IRC_UMODE_w,
    IRC_UMODE_x,
    0,
    0,
    0, 0, 0, 0, 0
};


char myCsmodes[128] = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    0,
    0,
    0, 0, 0,
    'h',                        /* (37) % Channel halfops */
    0,
    0, 0, 0,
    'q',

    'v', 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    'o', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'a', 0
};

CMMode myCmmodes[128] = {
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL},
    {NULL, NULL},
    {add_ban, del_ban},
    {NULL, NULL},
    {NULL, NULL},
    {add_exception, del_exception},
    {NULL, NULL},
    {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
    {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL}, {NULL, NULL},
};



CBMode myCbmodes[128] = {
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0},
    {IRCD_CMODE_A, NULL},
    {0, 0},                        /* B */
    {IRCD_CMODE_C, NULL},            /* C */
    {0, 0},                        /* D */
    {0, 0},                        /* E */
    {0, 0},                        /* F */
    {IRCD_CMODE_G, NULL},            /* G */
    {IRCD_CMODE_H, NULL},
    {0, 0},                        /* I */
    {0, 0},                        /* J */
    {IRCD_CMODE_K, NULL},            /* K */
    {IRCD_CMODE_L, set_redirect},
    {0, 0},                        /* M */
    {IRCD_CMODE_N, NULL},            /* N */
    {IRCD_CMODE_O, NULL},
    {0, 0},                        /* P */
    {IRCD_CMODE_Q, NULL},            /* Q */
    {IRCD_CMODE_R, NULL},            /* R */
    {IRCD_CMODE_S, NULL},            /* S */
    {0, 0},                        /* T */
    {0, 0},                        /* U */
    {IRCD_CMODE_V, NULL},            /* V */
    {0, 0},                        /* W */
    {0, 0},                        /* X */
    {0, 0},                        /* Y */
    {0, 0},                        /* Z */
    {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0},
    {0, 0},                        /* a */
    {0, 0},                        /* b */
    {IRCD_CMODE_c, NULL},
    {0, 0},                        /* d */
    {0, 0},                        /* e */
    {IRCD_CMODE_f, set_flood},
    {0, 0},                        /* g */
    {0, 0},                        /* h */
    {IRCD_CMODE_i, NULL},
    {0, 0},                        /* j */
    {IRCD_CMODE_k, set_key},
    {IRCD_CMODE_l, set_limit},
    {IRCD_CMODE_m, NULL},
    {IRCD_CMODE_n, NULL},
    {0, 0},                        /* o */
    {IRCD_CMODE_p, NULL},
    {0, 0},                        /* q */
    {IRCD_CMODE_r, NULL},
    {IRCD_CMODE_s, NULL},
    {IRCD_CMODE_t, NULL},
    {IRCD_CMODE_u, NULL},
    {0, 0},                        /* v */
    {0, 0},                        /* w */
    {0, 0},                        /* x */
    {0, 0},                        /* y */
    {IRCD_CMODE_z, NULL},
    {0, 0}, {0, 0}, {0, 0}, {0, 0}
};

CBModeInfo myCbmodeinfos[] = {
    {'c', IRCD_CMODE_c, NULL},
    {'f', IRCD_CMODE_f, get_flood},
    {'i', IRCD_CMODE_i, NULL},
    {'k', IRCD_CMODE_k, get_key},
    {'l', IRCD_CMODE_l, get_limit},
    {'m', IRCD_CMODE_m, NULL},
    {'n', IRCD_CMODE_n, NULL},
    {'p', IRCD_CMODE_p, NULL},
    {'r', IRCD_CMODE_r, NULL},
    {'s', IRCD_CMODE_s, NULL},
    {'t', IRCD_CMODE_t, NULL},
    {'u', IRCD_CMODE_u, NULL},
    {'z', IRCD_CMODE_z, NULL},
    {'A', IRCD_CMODE_A, NULL},
    {'C', IRCD_CMODE_C, NULL},
    {'G', IRCD_CMODE_G, NULL},
    {'H', IRCD_CMODE_H, NULL},
    {'K', IRCD_CMODE_K, NULL},
    {'L', IRCD_CMODE_L, get_redirect},
    {'N', IRCD_CMODE_N, NULL},
    {'O', IRCD_CMODE_O, NULL},
    {'Q', IRCD_CMODE_Q, NULL},
    {'R', IRCD_CMODE_R, NULL},
    {'S', IRCD_CMODE_S, NULL},
    {'V', IRCD_CMODE_V, NULL},
};

/* *INDENT-OFF* */
void moduleAddIRCDMsgs(void) {
    Message *m;

    m = createMessage("401",       denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("402",       denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("436",       denora_event_436); addCoreMessage(IRCD,m);
    m = createMessage("AWAY",      denora_event_away); addCoreMessage(IRCD,m);
    m = createMessage("INVITE",    denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("JOIN",      denora_event_join); addCoreMessage(IRCD,m);
    m = createMessage("KICK",      denora_event_kick); addCoreMessage(IRCD,m);
    m = createMessage("KILL",      denora_event_kill); addCoreMessage(IRCD,m);
    m = createMessage("MODE",      denora_event_mode); addCoreMessage(IRCD,m);
    m = createMessage("MOTD",      denora_event_motd); addCoreMessage(IRCD,m);
    m = createMessage("NICK",      denora_event_nick); addCoreMessage(IRCD,m);
    m = createMessage("NOTICE",    denora_event_notice); addCoreMessage(IRCD,m);
    m = createMessage("PART",      denora_event_part); addCoreMessage(IRCD,m);
    m = createMessage("PASS",      denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("PING",      denora_event_ping); addCoreMessage(IRCD,m);
    m = createMessage("PRIVMSG",   denora_event_privmsg); addCoreMessage(IRCD,m);
    m = createMessage("QUIT",      denora_event_quit); addCoreMessage(IRCD,m);
    m = createMessage("SERVER",    denora_event_server); addCoreMessage(IRCD,m);
    m = createMessage("SQUIT",     denora_event_squit); addCoreMessage(IRCD,m);
    m = createMessage("TOPIC",     denora_event_topic); addCoreMessage(IRCD,m);
    m = createMessage("USER",      denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("WALLOPS",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("WHOIS",     denora_event_whois); addCoreMessage(IRCD,m);
    m = createMessage("AKILL",     denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("GLOBOPS",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("GNOTICE",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("GOPER",     denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("RAKILL",    denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SILENCE",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSKILL",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSMODE",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSNICK",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SVSNOOP",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SQLINE",    denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("UNSQLINE",  denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("PROTOCTL",  denora_event_capab); addCoreMessage(IRCD,m);
    m = createMessage("CHGHOST",   denora_event_chghost); addCoreMessage(IRCD,m);
    m = createMessage("CHGIDENT",  denora_event_chgident); addCoreMessage(IRCD,m);
    m = createMessage("CHGNAME",   denora_event_chgname); addCoreMessage(IRCD,m);
    m = createMessage("NETINFO",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("SETHOST",   denora_event_sethost); addCoreMessage(IRCD,m);
    m = createMessage("SETIDENT",  denora_event_setident); addCoreMessage(IRCD,m);
    m = createMessage("SETNAME",   denora_event_setname); addCoreMessage(IRCD,m);
    m = createMessage("REHASH",    denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("ADMIN",     denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("CREDITS",   denora_event_null); addCoreMessage(IRCD,m);
    m = createMessage("PONG",       denora_event_pong); addCoreMessage(IRCD,m);

}

/* *INDENT-ON* */

/* Event: PROTOCTL */
int denora_event_capab(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    capab_parse(ac, av);
    return MOD_CONT;
}

void unreal31_cmd_nick(char *nick, char *name, const char *modes)
{
    send_cmd(NULL, "NICK %s 1 %ld %s %s %s 0 %s * :%s", nick,
             (long int) time(NULL), ServiceUser, ServiceHost, ServerName,
             modes, name);
}

void unreal31_cmd_bot_nick(char *nick, char *user, char *host, char *real,
                         char *modes)
{
    send_cmd(NULL, "NICK %s 1 %ld %s %s %s 0 %s * :%s", nick,
             (long int) time(NULL), user, host, ServerName, modes, real);
}

void unreal31_cmd_notice(char *source, char *dest, char *buf)
{
    send_cmd(source, "NOTICE %s :%s", dest, buf);
}

void unreal31_cmd_stats(char *sender, const char *letter, char *server)
{
    send_cmd(sender, "STATS %s %s", letter, server);
}

void unreal31_cmd_privmsg(char *source, char *dest, char *buf)
{
    send_cmd(source, "PRIVMSG %s :%s", dest, buf);
}

void unreal31_cmd_serv_notice(char *source, char *dest, char *msg)
{
    send_cmd(source, "NOTICE $%s :%s", dest, msg);
}

void unreal31_cmd_serv_privmsg(char *source, char *dest, char *msg)
{
    send_cmd(source, "PRIVMSG $%s :%s", dest, msg);
}

void unreal31_cmd_351(char *source)
{
    send_cmd(ServerName,
             "351 %s Denora-%s %s :%s -- build #%s, compiled %s %s",
             source, denora->version, ServerName, ircd->name, denora->build, denora->date, denora->time);
}

/* QUIT */
void unreal31_cmd_quit(char *source, char *buf)
{
    if (buf) {
        send_cmd(source, "QUIT :%s", buf);
    } else {
        send_cmd(source, "QUIT");
    }
}

/* PROTOCTL */
void unreal31_cmd_capab()
{
    /*
       See Unreal's protoctl.txt for reference
       VHP - Send hostnames in NICKv2 even if not sethosted
     */
    send_cmd(NULL, "PROTOCTL NICKv2 VHP");
}

/* PASS */
void unreal31_cmd_pass(char *pass)
{
    send_cmd(NULL, "PASS :%s", pass);
}

/* SERVER name hop descript */
void unreal31_cmd_server(char *servname, int hop, char *descript)
{
    send_cmd(NULL, "SERVER %s %d :%s", servname, hop, descript);
}

/* PONG */
void unreal31_cmd_pong(char *servname, char *who)
{
    send_cmd(servname, "PONG %s", who);
}

/* JOIN */
void unreal31_cmd_join(char *user, char *channel, time_t chantime)
{
    alog(LOG_PROTOCOL,"User %s joins %s at %ld", user, channel, (long int) chantime);
    send_cmd(user, "JOIN %s", channel);

    if (AutoOp)
        send_cmd(ServerName, "MODE %s +o %s", channel, user);
}

/* PART */
void unreal31_cmd_part(char *nick, char *chan, char *buf)
{
    if (buf) {
        send_cmd(nick, "PART %s :%s", chan, buf);
    } else {
        send_cmd(nick, "PART %s", chan);
    }
}

/* GLOBOPS */
void unreal31_cmd_global(char *source, char *buf)
{
    send_cmd(source ? source : ServerName, "GLOBOPS :%s", buf);
}

/* SQUIT */
void unreal31_cmd_squit(char *servname, char *message)
{
    send_cmd(NULL, "SQUIT %s :%s", servname, message);
}

void unreal31_cmd_connect()
{
    char *hops;

    hops = sstrdup("0");
    me_server = do_server(NULL, ServerName, hops, ServerDesc, NULL);
    denora_free(hops);

    unreal31_cmd_capab();
    unreal31_cmd_pass(RemotePassword);
    unreal31_cmd_server(ServerName, 1, ServerDesc);
}

/* Events */

int denora_event_ping(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 1)
        return MOD_CONT;
    unreal31_cmd_pong(ac > 1 ? av[1] : ServerName, av[0]);
    return MOD_CONT;
}

int denora_event_436(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 1)
        return MOD_CONT;

    m_nickcoll(av[0]);
    return MOD_CONT;
}

int denora_event_away(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (!ac) {
       m_away(source, NULL);
    } else {
       m_away(source, av[0]);
    }
    return MOD_CONT;
}

int denora_event_pong(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
  server_store_pong(source, time(NULL));
  return MOD_CONT;
}

int denora_event_topic(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 4)
        return MOD_CONT;
    do_topic(ac, av);
    return MOD_CONT;
}

int denora_event_squit(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2)
        return MOD_CONT;
    do_squit(av[0]);
    return MOD_CONT;
}

int denora_event_quit(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 1)
        return MOD_CONT;
    do_quit(source, ac, av);
    return MOD_CONT;
}


int denora_event_mode(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 2)
        return MOD_CONT;

    if (*av[0] == '#' || *av[0] == '&') {
        do_cmode(source, ac, av);
    } else {
        do_umode(source, ac, av);
    }
    return MOD_CONT;
}

int denora_event_kill(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2)
        return MOD_CONT;

    m_kill(source, av[0], av[1]);
    return MOD_CONT;
}

int denora_event_kick(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 3)
        return MOD_CONT;
    do_kick(source, ac, av);
    return MOD_CONT;
}


int denora_event_join(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 1)
        return MOD_CONT;
    do_join(source, ac, av);
    return MOD_CONT;
}

int denora_event_motd(char *source, int ac, char **av)
{
  if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
  }
  m_motd(source);
  return MOD_CONT;
}

int denora_event_setname(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    change_user_realname(source, av[0]);
    return MOD_CONT;
}

int denora_event_chgname(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    change_user_realname(av[0], av[1]);
    return MOD_CONT;
}

int denora_event_setident(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    change_user_username(source, av[0]);
    return MOD_CONT;
}

int denora_event_chgident(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    change_user_username(av[0], av[1]);
    return MOD_CONT;
}

int denora_event_sethost(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    change_user_host(source, av[0]);
    return MOD_CONT;
}

int denora_event_nick(char *source, int ac, char **av)
{
    User *user;

    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }

    if (ac != 2) {
        if (ac == 7) {
            /*
               <codemastr> that was a bug that is now fixed in 3.2.1
               <codemastr> in  some instances it would use the non-nickv2 format
               <codemastr> it's sent when a nick collision occurs
               - so we have to leave it around for now -TSL
             */
            do_nick(source, av[0], av[3], av[4], av[5], av[6],
                    strtoul(av[2], NULL, 10), 0, 0, NULL, NULL, 0, NULL);
        } else {
            user = do_nick(source, av[0], av[3], av[4], av[5], av[9],
                           strtoul(av[2], NULL, 10), strtoul(av[6], NULL,
                                                             0), 0, av[8],
                           NULL, strtoul(av[1], NULL, 10), av[7]);
            if (user)
                denora_set_umode(user, 1, &av[7]);
        }
    } else {
        do_nick(source, av[0], NULL, NULL, NULL, NULL,
                strtoul(av[1], NULL, 10), 0, 0, NULL, NULL, 0, NULL);
    }
    return MOD_CONT;
}

int denora_event_chghost(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    change_user_host(av[0], av[1]);
    return MOD_CONT;
}

/* EVENT: SERVER */
int denora_event_server(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (!stricmp(av[1], "1")) {
        denora->uplink = sstrdup(av[0]);
        me_server->uplink = sstrdup(av[0]);
        do_server(source, av[0], av[1], av[2], NULL);
        return MOD_CONT;
    }
    do_server(source, av[0], av[1], av[2], NULL);
    return MOD_CONT;
}

int denora_event_privmsg(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2)
        return MOD_CONT;
    m_privmsg(source, av[0], av[1]);
    return MOD_CONT;
}

int denora_event_part(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac < 1 || ac > 2)
        return MOD_CONT;
    do_part(source, ac, av);
    return MOD_CONT;
}

int denora_event_whois(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (source && ac >= 1) {
        m_whois(source, av[0]);
    }
    return MOD_CONT;
}

void unreal31_cmd_eob()
{
    /* Can anyone tell me if 3.1 has this? */
}

void unreal31_cmd_ping(char *server)
{
    send_cmd(ServerName, "PING %s :%s", ServerName, server);
}

void unreal31_cmd_ctcp(char *source, char *dest, char *buf)
{
    send_cmd(source, "%s NOTICE :\1%s \1", dest, buf);
}

void unreal31_cmd_version(char *server)
{
    send_cmd(s_StatServ, "VERSION %s", server);
}

void unreal31_cmd_motd(char *sender, char *server)
{
    send_cmd(sender, "MOTD %s", server);
}

int denora_event_notice(char *source, int ac, char **av)
{
    if (denora->protocoldebug) {
        protocol_debug(source, ac, av);
    }
    if (ac != 2) {
        return MOD_CONT;
    }
    m_notice(source, av[0], av[1]);
    return MOD_CONT;
}

void unreal31_cmd_mode(char *source, char *dest, char *buf)
{
    send_cmd(source, "MODE %s %s", dest, buf);
}

void moduleAddIRCDCmds() {
    pmodule_cmd_nick(unreal31_cmd_nick);
    pmodule_cmd_mode(unreal31_cmd_mode);
    pmodule_cmd_bot_nick(unreal31_cmd_bot_nick);
    pmodule_cmd_notice(unreal31_cmd_notice);
    pmodule_cmd_privmsg(unreal31_cmd_privmsg);
    pmodule_cmd_serv_notice(unreal31_cmd_serv_notice);
    pmodule_cmd_serv_privmsg(unreal31_cmd_serv_privmsg);
    pmodule_cmd_351(unreal31_cmd_351);
    pmodule_cmd_quit(unreal31_cmd_quit);
    pmodule_cmd_pong(unreal31_cmd_pong);
    pmodule_cmd_join(unreal31_cmd_join);
    pmodule_cmd_part(unreal31_cmd_part);
    pmodule_cmd_global(unreal31_cmd_global);
    pmodule_cmd_squit(unreal31_cmd_squit);
    pmodule_cmd_connect(unreal31_cmd_connect);
    pmodule_cmd_eob(unreal31_cmd_eob);
    pmodule_cmd_ctcp(unreal31_cmd_ctcp);
    pmodule_cmd_version(unreal31_cmd_version);
    pmodule_cmd_stats(unreal31_cmd_stats);
    pmodule_cmd_motd(unreal31_cmd_motd);
    pmodule_cmd_ping(unreal31_cmd_ping);
}

int DenoraInit(int argc, char **argv) 
{
  if (denora->protocoldebug) {
        protocol_debug(NULL, argc, argv);
  }
	moduleAddAuthor("Denora");
    moduleAddVersion("$Id: unreal31.c 433 2005-07-26 16:58:24Z drstein $");
    moduleSetType(PROTOCOL);

    pmodule_ircd_version("UnrealIRCd 3.1+");
    pmodule_ircd_cap(myIrcdcap);
    pmodule_ircd_var(myIrcd);
    pmodule_ircd_cbmodeinfos(myCbmodeinfos);
    pmodule_ircd_cbmodes(myCbmodes);
    pmodule_ircd_cmmodes(myCmmodes);
    pmodule_ircd_umodes(myumodes);
    pmodule_ircd_csmodes(myCsmodes);
    pmodule_ircd_useTSMode(0);
    pmodule_irc_var(IRC_UNREAL31);
	pmodule_oper_umode(IRC_UMODE_o);

    moduleAddIRCDCmds();
    moduleAddIRCDMsgs();

    return MOD_CONT;
}

